<template>
  <v-main>
    <StartModal />
    <Toolbar />
    <Editor />
    <v-stage
      ref="mainStage"
      class="full-size dark"
      :config="stageConfig"
      @mousedown="cancelEdition()"
      @mouseup="mouseup"
      @mousemove="updateTmpLink"
      @dragstart="dragStart"
      @dragend="dragEnd"
    >
      <NodesLayer :nodes="nodes" />
      <NodesLayer :nodes="[draggedNode]" :dragAtStart="true" v-if="draggedNode" />
      <LinksLayer :links="draggedLinks" />
      <LinksLayer :links="links" />
      <template v-if="isDrawingLink">
        <v-layer ref="tmpLinkLayer">
          <v-line :config="tmpLink" />
        </v-layer>
      </template>
    </v-stage>
  </v-main>
</template>

<script type="ts">
  import Editor from '@/components/Editor'
  import Toolbar from '@/components/Toolbar'
  import StartModal from '@/components/StartModal'
  import GraphicLink from '@/components/GraphicLink'
  import NodesLayer from '@/components/layers/NodesLayer'
  import LinksLayer from '@/components/layers/LinksLayer'
  import { mapState, mapMutations } from 'vuex'

  export default {
    name: 'Synth',
    components: { Toolbar, GraphicLink, Editor, StartModal, NodesLayer, LinksLayer },
    data: () => ({
      stageConfig: {
        height: window.innerHeight,
        width: window.innerWidth,
        draggable: true,
        scale: {x: 1, y: 1}
      },
      layer: new Konva.Layer()
    }),
    computed: {
      ...mapState(["nodes", "scale", "links"]),
      ...mapState("dragAndDrop", ["draggedNode", "draggedLinks"]),
      ...mapState("connections", ["tmpLink", "isDrawingLink"]),
    },
    methods: {
      resizeCanva() {
        this.stageConfig.height = window.innerHeight;
        this.stageConfig.width = window.innerWidth;
      },
      scaleCanva(e) {
        this.triggerZoomScaling(e)
        this.stageConfig.scale = {
          x: this.scale,
          y: this.scale
        };
      },
      mouseup($event) {
        this.triggerDragEnd({node: this.draggedNode, event: $event})
        if (this.isDrawingLink) {
          this.cancelDrawnLink()
        }
      },
      ...mapMutations(["dragStart", "dragEnd"]),
      ...mapMutations("keyboard", ["keyup", "keydown"]),
      ...mapMutations(["cancelEdition", "triggerZoomScaling"]),
      ...mapMutations("dragAndDrop", ["triggerDragEnd"]),
      ...mapMutations("connections", ["updateTmpLink", "cancelDrawnLink"])
    },
    created() {
      window.addEventListener("resize", this.resizeCanva);
      window.onwheel = this.scaleCanva
      window.addEventListener("keydown", this.keydown);
      window.addEventListener("keyup", this.keyup);
    },
    destroyed() {
      window.removeEventListener("resize", this.resizeCanva);
    }
  }
</script>

<style>
  .full-size {
    width: 100%;
    height: 100%;
  }

  .dark {
    background-color:#BDBDBD;
  }
</style>
